/* Sistemas Integrados TECNISA

Nome: 9806_GERTRGO_LOG_GER_UNIDADE.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   14/01/2016 - Jurandir Junio
*/

/* Tabela UNIDMEDIDA.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              UNIDMEDIDA, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_GER_UNIDADE
AFTER DELETE OR INSERT OR UPDATE
ON UNIDMEDIDA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(300);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN

      IF :NEW.SGUNIDADE IS NOT NULL THEN
         V_DESC := V_DESC || 'SgUnidade= ' || NVL(:NEW.SGUNIDADE,'') || ' ' ;
      END IF;

      IF :NEW.DSUNIDADE IS NOT NULL THEN
         V_DESC := V_DESC || 'DsUnidade= ' || NVL(:NEW.DSUNIDADE,'') || ' ' ;
      END IF;

      IF :NEW.DTULTATUUNID IS NOT NULL THEN
         V_DESC := V_DESC || 'DtUltAtuUnid= ' || NVL(:NEW.DTULTATUUNID,'') || ' ' ;
      END IF;

      V_ITPESQ := :NEW.SGUNIDADE   || :NEW.DSUNIDADE   || :NEW.DTULTATUUNID;

      V_IDTIPOOPER := '1';

   END IF;

   IF UPDATING THEN

      IF (:NEW.SGUNIDADE <> :OLD.SGUNIDADE) THEN
         V_DESC := V_DESC || 'SgUnidade= ' || NVL(:NEW.SGUNIDADE,'') || ' ' ;
      END IF;

      IF (:NEW.DSUNIDADE <> :OLD.DSUNIDADE) THEN
         V_DESC := V_DESC || 'DsUnidade= ' || NVL(:NEW.DSUNIDADE,'') || ' ' ;
      END IF;

      IF (:NEW.DTULTATUUNID <> :OLD.DTULTATUUNID) THEN
         V_DESC := V_DESC || 'DtUltAtuUnid= ' || NVL(:NEW.DTULTATUUNID,'') || ' ' ;
      END IF;


      V_ITPESQ := :NEW.SGUNIDADE   || :NEW.DSUNIDADE   || :NEW.DTULTATUUNID;

      V_IDTIPOOPER := '2';

   END IF;

   IF DELETING  THEN

      IF :OLD.SGUNIDADE IS NOT NULL THEN
         V_DESC := V_DESC || 'SgUnidade= ' || NVL(:OLD.SGUNIDADE,'') || ' ' ;
      END IF;

      IF :OLD.DSUNIDADE IS NOT NULL THEN
         V_DESC := V_DESC || 'DsUnidade= ' || NVL(:OLD.DSUNIDADE,'') || ' ' ;
      END IF;

      IF :OLD.DTULTATUUNID IS NOT NULL THEN
         V_DESC := V_DESC || 'DtUltAtuUnid= ' || NVL(:OLD.DTULTATUUNID,'') || ' ' ;
      END IF;

      V_ITPESQ := :OLD.SGUNIDADE   || :OLD.DSUNIDADE   || :OLD.DTULTATUUNID;

      V_IDTIPOOPER := '3';

   END IF;

   IF NOT (V_DESC IS NULL) THEN

      INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                             DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                   VALUES  ('UNIDMEDIDA', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                             V_IDTIPOOPER,   V_DESC, V_ITPESQ,
                             V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                             V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER);
                             
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_UNIDADE','6.05.xxx'); END;
/    
